Package org.opensaml.xmlsec

# Interface SignatureSigningConfiguration

All Superinterfaces:
  `AlgorithmPolicyConfiguration`

All Known Implementing Classes:
  `BasicSignatureSigningConfiguration`

public interface SignatureSigningConfiguration extends AlgorithmPolicyConfiguration
The configuration information to use when generating an XML signature.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.opensaml.xmlsec.AlgorithmPolicyConfiguration

`AlgorithmPolicyConfiguration.Precedence`

## Method Summary

Modifier and Type
Method
Description
`NamedKeyInfoGeneratorManager`
`getKeyInfoGeneratorManager()`
Get the manager for named KeyInfoGenerator instances.
`List<String>`
`getSignatureAlgorithms()`
Get the list of preferred signature algorithm URIs, in preference order.
`String`
`getSignatureCanonicalizationAlgorithm()`
Get a canonicalization algorithm URI suitable for use as a Signature CanonicalizationMethod value.
`Integer`
`getSignatureHMACOutputLength()`
Get the value to be used as the Signature SignatureMethod HMACOutputLength value, used only when signing with an HMAC algorithm.
`String`
`getSignatureReferenceCanonicalizationAlgorithm()`
Get a canonicalization algorithm URI suitable for use as a Signature Reference Transform value.
`List<String>`
`getSignatureReferenceDigestMethods()`
Get the list of digest method algorithm URIs suitable for use as a Signature Reference DigestMethod value, in preference order.
`List<Credential>`
`getSigningCredentials()`
Get the list of signing credentials to use when signing, in preference order.

### Methods inherited from interface org.opensaml.xmlsec.AlgorithmPolicyConfiguration

`getExcludedAlgorithms, getIncludedAlgorithms, getIncludeExcludePrecedence, isExcludeMerge, isIncludeMerge`

## Method Details

### getSigningCredentials

@Nonnull @Unmodifiable @NotLive List<Credential> getSigningCredentials()
Get the list of signing credentials to use when signing, in preference order.

Returns:
  the list of signing credentials, may be empty

### getSignatureAlgorithms

@Nonnull @Unmodifiable @NotLive List<String> getSignatureAlgorithms()
Get the list of preferred signature algorithm URIs, in preference order.

Returns:
  the list of algorithm URIs, may be empty

### getSignatureReferenceDigestMethods

@Nonnull @Unmodifiable @NotLive List<String> getSignatureReferenceDigestMethods()
Get the list of digest method algorithm URIs suitable for use as a Signature Reference DigestMethod value, in preference order.

Returns:
  a digest method algorithm URI

### getSignatureReferenceCanonicalizationAlgorithm

@Nullable String getSignatureReferenceCanonicalizationAlgorithm()
Get a canonicalization algorithm URI suitable for use as a Signature Reference Transform value.

Returns:
  a digest method algorithm URI

### getSignatureCanonicalizationAlgorithm

@Nullable String getSignatureCanonicalizationAlgorithm()
Get a canonicalization algorithm URI suitable for use as a Signature CanonicalizationMethod value.

Returns:
  a canonicalization algorithm URI

### getSignatureHMACOutputLength

@Nullable Integer getSignatureHMACOutputLength()
Get the value to be used as the Signature SignatureMethod HMACOutputLength value, used only when signing with an HMAC algorithm. This value is optional when using HMAC.

Returns:
  the configured HMAC output length value

### getKeyInfoGeneratorManager

@Nullable NamedKeyInfoGeneratorManager getKeyInfoGeneratorManager()
Get the manager for named KeyInfoGenerator instances.

Returns:
  the KeyInfoGenerator manager, or null if none is configured